import java.util.ArrayList;
import info.gridworld.grid.Location;
import info.gridworld.actor.Actor;
import info.gridworld.actor.Critter;

public class StockpileCritter extends Critter
{
  private int stockpile = 0; // 0 by default

  public void processActors(ArrayList<Actor> actors)
  {
    for (Actor a : actors)
    {
      a.removeSelfFromGrid();
      stockpile++;
    }
  }

  public Location selectMoveLocation(ArrayList<Location> locs)
  {
    if(stockpile == 0)
      return null;
    return super.selectMoveLocation(locs);
  }

  public void makeMove(Location loc)
  {
    super.makeMove(loc);
    if (stockpile > 0)
      stockpile--;
  }
}

/*** Alternative solution, assuming stockpile is a list of actors

public class StockpileCritter extends Critter
{
  private ArrayList<Actor> stockpile;  // Assuming stockpile must be a list of actors

  public StockpileCritter()
  {
    stockpile = new ArrayList<Actor>();
  }

  public void processActors(ArrayList<Actor> actors)
  {
    for (Actor a : actors)
    {
      a.removeSelfFromGrid();
      stockpile.add(a);
    }
  }

  public Location selectMoveLocation(ArrayList<Location> locs)
  {
    if(stockpile.isEmpty())
      return null;
    return super.selectMoveLocation(locs);
  }

  public void makeMove(Location loc)
  {
    super.makeMove(loc);
    if (!stockpile.isEmpty())
      stockpile.remove(0);  // or stockpile.remove(stockpile.size() - 1);
  }
}

***/