public class ArithmeticNumberStream implements IncreasingNumberStream
{
  private int startValue, nextValue, increment;

  public ArithmeticNumberStream(int sv, int inc)
  {
    startValue = sv;
    nextValue = sv;
    increment = inc;
  }

  public int nextTerm() // Method names are determined by the IncreasingNumberStream interface
  {
    int saved = nextValue;

    if ((double)nextValue + increment >
                  (double)Integer.MAX_VALUE) // cast to double to avoid arithmetic overflow
      nextValue = Integer.MAX_VALUE;
    else
      nextValue += increment;

    return saved;
  }

  public void restart()
  {
    nextValue = startValue;
  }

  // *************************************************

  public static void main(String[] args)
  {
    IncreasingNumberStream stream = new ArithmeticNumberStream(12, 5);
    System.out.print(stream.nextTerm() + " ");
    System.out.print(stream.nextTerm() + " ");
    System.out.print(stream.nextTerm() + " ");
    stream.restart();
    System.out.print(stream.nextTerm() + " ");
    System.out.println(stream.nextTerm());

    System.out.println("*** " + Integer.MAX_VALUE + " ***");

    stream = new ArithmeticNumberStream(12, Integer.MAX_VALUE/3);
    System.out.print(stream.nextTerm() + " ");
    System.out.print(stream.nextTerm() + " ");
    System.out.print(stream.nextTerm() + " ");
    System.out.print(stream.nextTerm() + " ");
    System.out.print(stream.nextTerm() + " ");
    System.out.println(stream.nextTerm() + " ");
  }
}
